import pgzrun
import random
import sys
from pgzero.builtins import Actor, animate, keyboard
TITLE = "BALLOON POPPER FREE DOWNLOAD NO VIRUS 8K"
WIDTH = 500
HEIGHT = 1000
game_state = 'title'
score = int(0)
man = Actor('man', (250, 180))
balloons = []
darts = []
dart = Actor('dart')
dart_fire = False
lives = 10
def draw_balloons():
    global balloons
    for balloon in balloons:
        balloon.draw()
def draw_dart():
    global darts
    for dart in darts:
        dart.draw()
def draw():
    global score
    global game_state
    global lives
    if game_state == 'title':
        lives = 10
        score = 0
        screen.clear()
        screen.blit('title_screen', (0, 0))
    if game_state == 'game':
        screen.clear()
        screen.blit('background', (0, 0))
        draw_balloons()
        man.draw()
        if dart_fire == True:
            draw_dart()
        screen.draw.text("score " + str(score), (10, 10), color="black")
        screen.draw.text("lives " + str(lives), (425, 10), color="black")
    if game_state == 'game_over':
        screen.clear()
        screen.blit('game_over_screen', (0,0))
        screen.draw.text("The world is destroyed and its all your fault \n it has nothing to do with capitalism \n backspace to return to title", (100, 250))
def check_keys(dt):
    if keyboard.LEFT or keyboard.A:
        man.x -= dt * 250
    if keyboard.RIGHT or keyboard.D:
        man.x += dt * 250
def on_key_down(key):
    global dart_fire
    global game_state
    if key == keys.RETURN and game_state == 'title':
        game_state = 'game'
        clock.schedule_interval(spawn_balloon, 0.5)
    elif key == keys.BACKSPACE and game_state == 'game_over':
        game_state = 'title'
        clock.unschedule(spawn_balloon)
        screen.clear()
    elif key == keys.SPACE:
        dart_fire = True
        spawn_dart()
    elif game_state == 'title' and key == key.ESCAPE:
        sys.exit()
def spawn_dart():
    global darts
    dart = Actor('dart')
    dart.pos = man.pos
    dart.render = True
    darts.append(dart)
def dart_checker(dt):
    global dart_fire
    global darts
    if dart_fire == True:
        for dart in darts:
            dart.y += dt * 1000
            
def spawn_balloon():
    global balloons
    
    balloon = Actor('balloon')
    
    xpos = random.randint(balloon.width, WIDTH - balloon.width)
    balloon.midbottom = (xpos, 1000)
    balloon.render = True
    balloons.append(balloon)
def move_balloon(dt):
    global balloons
    for balloon in balloons:
        if score <= 10:
            balloon.y -= dt*75
        elif score <= 20:
            balloon.y -= dt * 80
        elif score <= 68:
            balloon.y -= dt * 90
        elif score == 69:
            balloon.y -= dt * 10000
        elif score >= 70:
            balloon.y -= dt * 100
        elif score >= 80:
            balloon.y -= dt * 200
def check_collisions():
    global balloons
    global darts
    global score
    for dart in darts:
        for balloon in balloons:
            if dart.colliderect(balloon):
                balloon.render = False
                dart.render = False
                score += 1
def cleanup():
    global darts
    global balloons
    new_darts = []
    for dart in darts:
        if not dart.bottom < 0 and dart.render:
            new_darts.append(dart)
    darts = new_darts
    
    new_balloons = []
    for balloon in  balloons:
        if not balloon.top > HEIGHT and balloon.render:
            new_balloons.append(balloon)
        else:
            balloon.render = False
    balloons = new_balloons
            
def life_checker():
    global balloons
    global lives
    global game_state
    balloony = []
    for balloon in balloons:
        if balloon.y < 0:
            lives -= 1
        else:
            balloony.append(balloon)
    balloons = balloony
    if lives <= 0 and game_state == 'game':
       game_state = 'game_over'
def update(dt):
    check_keys(dt)
    dart_checker(dt)
    move_balloon(dt)
    check_collisions()
    life_checker()
    cleanup()
pgzrun.go()
#if dart y value greater than n, add to miss count.
#if miss count is greater than t , game over 